diff --git a/roms/ipxe/src/arch/i386/include/librm.h b/roms/ipxe/src/arch/i386/include/librm.h
index c6992f64395d581c30031a780b9a..801f586b8e39c8291e16b2ebe080 100644
--- a/roms/ipxe/src/arch/i386/include/librm.h
+++ b/roms/ipxe/src/arch/i386/include/librm.h
@@ -68,6 +68,12 @@ UACCESS_INLINE ( librm, userptr_add ) ( userptr_t userptr, off_t offset ) {
 	return trivial_userptr_add ( userptr, offset );
 }
 
+static inline __always_inline off_t
+UACCESS_INLINE ( librm, userptr_sub ) ( userptr_t userptr,
+					userptr_t subtrahend ) {
+	return trivial_userptr_sub ( userptr, subtrahend );
+}
+
 static inline __always_inline void
 UACCESS_INLINE ( librm, memcpy_user ) ( userptr_t dest, off_t dest_off,
 					userptr_t src, off_t src_off,
diff --git a/roms/ipxe/src/arch/i386/include/pcbios/ipxe/dhcp_arch.h b/roms/ipxe/src/arch/i386/include/pcbios/ipxe/dhcp_arch.h
index 822b3eba9100f0e762f1117a49fa..a36d9cfa18c86d456e3c7d47ba5c 100644
--- a/roms/ipxe/src/arch/i386/include/pcbios/ipxe/dhcp_arch.h
+++ b/roms/ipxe/src/arch/i386/include/pcbios/ipxe/dhcp_arch.h
@@ -33,7 +33,8 @@ FILE_LICENCE ( GPL2_OR_LATER );
 		      'A', 'r', 'c', 'h', ':', '0', '0', '0', '0', '0', ':', \
 		      'U', 'N', 'D', 'I', ':', '0', '0', '2', '0', '0', '1' )
 
-#define DHCP_ARCH_CLIENT_ARCHITECTURE DHCP_WORD ( 0 )
+#define DHCP_ARCH_CLIENT_ARCHITECTURE \
+	DHCP_WORD ( DHCP_CLIENT_ARCHITECTURE_X86 )
 
 #define DHCP_ARCH_CLIENT_NDI DHCP_OPTION ( 1 /* UNDI */ , 2, 1 /* v2.1 */ )
 
diff --git a/roms/ipxe/src/arch/i386/include/pic8259.h b/roms/ipxe/src/arch/i386/include/pic8259.h
index f8e20c4c46c4fac607215575b349..a07e97d30602acd6153cb8a2fd34 100644
--- a/roms/ipxe/src/arch/i386/include/pic8259.h
+++ b/roms/ipxe/src/arch/i386/include/pic8259.h
@@ -9,6 +9,8 @@ FILE_LICENCE ( GPL2_OR_LATER );
 #ifndef PIC8259_H
 #define PIC8259_H
 
+#include <ipxe/io.h>
+
 /* For segoff_t */
 #include "realmode.h"
 
diff --git a/roms/ipxe/src/arch/i386/include/pxe.h b/roms/ipxe/src/arch/i386/include/pxe.h
index 909c8d818af1b0a1fab165479799..0206f683ae01f89c2ec8dff536cf 100644
--- a/roms/ipxe/src/arch/i386/include/pxe.h
+++ b/roms/ipxe/src/arch/i386/include/pxe.h
@@ -6,8 +6,12 @@ FILE_LICENCE ( GPL2_OR_LATER );
 #include "pxe_types.h"
 #include "pxe_api.h"
 #include <ipxe/device.h>
+#include <ipxe/tables.h>
 
-/* Parameter block for pxenv_unknown() */
+/** PXE API invalid function code */
+#define PXENV_UNKNOWN 0xffff
+
+/** Parameter block for pxenv_unknown() */
 struct s_PXENV_UNKNOWN {
 	PXENV_STATUS_t Status;			/**< PXE status code */
 } __attribute__ (( packed ));
@@ -72,6 +76,45 @@ union u_PXENV_ANY {
 
 typedef union u_PXENV_ANY PXENV_ANY_t;
 
+/** A PXE API call */
+struct pxe_api_call {
+	/** Entry point
+	 *
+	 * @v params		PXE API call parameters
+	 * @ret exit		PXE API call exit code
+	 */
+	PXENV_EXIT_t ( * entry ) ( union u_PXENV_ANY *params );
+	/** Length of parameters */
+	uint16_t params_len;
+	/** Opcode */
+	uint16_t opcode;
+};
+
+/** PXE API call table */
+#define PXE_API_CALLS __table ( struct pxe_api_call, "pxe_api_calls" )
+
+/** Declare a PXE API call */
+#define __pxe_api_call __table_entry ( PXE_API_CALLS, 01 )
+
+/**
+ * Define a PXE API call
+ *
+ * @v _opcode		Opcode
+ * @v _entry		Entry point
+ * @v _params_type	Type of parameter structure
+ * @ret call		PXE API call
+ */
+#define PXE_API_CALL( _opcode, _entry, _params_type ) {			      \
+	.entry = ( ( ( ( PXENV_EXIT_t ( * ) ( _params_type *params ) ) NULL ) \
+		    == ( ( typeof ( _entry ) * ) NULL ) )		      \
+		   ? ( ( PXENV_EXIT_t ( * )				      \
+			 ( union u_PXENV_ANY *params ) ) _entry )	      \
+		   : ( ( PXENV_EXIT_t ( * )				      \
+			 ( union u_PXENV_ANY *params ) ) _entry ) ),	      \
+	.params_len = sizeof ( _params_type ),				      \
+	.opcode = _opcode,						      \
+	}
+
 /** An UNDI expansion ROM header */
 struct undi_rom_header {
 	/** Signature
@@ -144,9 +187,12 @@ struct pcir_header {
 #define PCIR_SIGNATURE \
 	( ( 'P' << 0 ) + ( 'C' << 8 ) + ( 'I' << 16 ) + ( 'R' << 24 ) )
 
-
 extern struct net_device *pxe_netdev;
+extern const char *pxe_cmdline;
 
 extern void pxe_set_netdev ( struct net_device *netdev );
+extern PXENV_EXIT_t pxenv_tftp_read_file ( struct s_PXENV_TFTP_READ_FILE
+					   *tftp_read_file );
+extern PXENV_EXIT_t undi_loader ( struct s_UNDI_LOADER *undi_loader );
 
 #endif /* PXE_H */
diff --git a/roms/ipxe/src/arch/i386/include/pxe_api.h b/roms/ipxe/src/arch/i386/include/pxe_api.h
index 9b40187ed102b115d482c3379bcd..e4396efb2307e332999db209e8e5 100644
--- a/roms/ipxe/src/arch/i386/include/pxe_api.h
+++ b/roms/ipxe/src/arch/i386/include/pxe_api.h
@@ -14,7 +14,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  *
  * As an alternative, at your option, you may use this file under the
  * following terms, known as the "MIT license":
@@ -252,9 +253,6 @@ struct s_PXENV_UNLOAD_STACK {
 
 typedef struct s_PXENV_UNLOAD_STACK PXENV_UNLOAD_STACK_t;
 
-extern PXENV_EXIT_t pxenv_unload_stack ( struct s_PXENV_UNLOAD_STACK
-					 *unload_stack );
-
 /** @} */ /* pxenv_unload_stack */
 
 /** @defgroup pxenv_get_cached_info PXENV_GET_CACHED_INFO
@@ -403,9 +401,6 @@ struct bootph {
 
 typedef struct bootph BOOTPLAYER_t;
 
-extern PXENV_EXIT_t pxenv_get_cached_info ( struct s_PXENV_GET_CACHED_INFO
-					    *get_cached_info );
-
 /** @} */ /* pxenv_get_cached_info */
 
 /** @defgroup pxenv_restart_tftp PXENV_RESTART_TFTP
@@ -423,9 +418,6 @@ struct s_PXENV_TFTP_READ_FILE;
 
 typedef struct s_PXENV_RESTART_TFTP PXENV_RESTART_TFTP_t;
 
-extern PXENV_EXIT_t pxenv_restart_tftp ( struct s_PXENV_TFTP_READ_FILE
-					 *restart_tftp );
-
 /** @} */ /* pxenv_restart_tftp */
 
 /** @defgroup pxenv_start_undi PXENV_START_UNDI
@@ -496,8 +488,6 @@ struct s_PXENV_START_UNDI {
 
 typedef struct s_PXENV_START_UNDI PXENV_START_UNDI_t;
 
-extern PXENV_EXIT_t pxenv_start_undi ( struct s_PXENV_START_UNDI *start_undi );
-
 /** @} */ /* pxenv_start_undi */
 
 /** @defgroup pxenv_stop_undi PXENV_STOP_UNDI
@@ -517,8 +507,6 @@ struct s_PXENV_STOP_UNDI {
 
 typedef struct s_PXENV_STOP_UNDI PXENV_STOP_UNDI_t;
 
-extern PXENV_EXIT_t pxenv_stop_undi ( struct s_PXENV_STOP_UNDI *stop_undi );
-
 /** @} */ /* pxenv_stop_undi */
 
 /** @defgroup pxenv_start_base PXENV_START_BASE
@@ -538,8 +526,6 @@ struct s_PXENV_START_BASE {
 
 typedef struct s_PXENV_START_BASE PXENV_START_BASE_t;
 
-extern PXENV_EXIT_t pxenv_start_base ( struct s_PXENV_START_BASE *start_base );
-
 /** @} */ /* pxenv_start_base */
 
 /** @defgroup pxenv_stop_base PXENV_STOP_BASE
@@ -559,8 +545,6 @@ struct s_PXENV_STOP_BASE {
 
 typedef struct s_PXENV_STOP_BASE PXENV_STOP_BASE_t;
 
-extern PXENV_EXIT_t pxenv_stop_base ( struct s_PXENV_STOP_BASE *stop_base );
-
 /** @} */ /* pxenv_stop_base */
 
 /** @} */ /* pxe_preboot_api */
@@ -600,8 +584,6 @@ struct s_PXENV_TFTP_OPEN {
 
 typedef struct s_PXENV_TFTP_OPEN PXENV_TFTP_OPEN_t;
 
-extern PXENV_EXIT_t pxenv_tftp_open ( struct s_PXENV_TFTP_OPEN *tftp_open );
-
 /** @} */ /* pxenv_tftp_open */
 
 /** @defgroup pxenv_tftp_close PXENV_TFTP_CLOSE
@@ -621,8 +603,6 @@ struct s_PXENV_TFTP_CLOSE {
 
 typedef struct s_PXENV_TFTP_CLOSE PXENV_TFTP_CLOSE_t;
 
-extern PXENV_EXIT_t pxenv_tftp_close ( struct s_PXENV_TFTP_CLOSE *tftp_close );
-
 /** @} */ /* pxenv_tftp_close */
 
 /** @defgroup pxenv_tftp_read PXENV_TFTP_READ
@@ -645,8 +625,6 @@ struct s_PXENV_TFTP_READ {
 
 typedef struct s_PXENV_TFTP_READ PXENV_TFTP_READ_t;
 
-extern PXENV_EXIT_t pxenv_tftp_read ( struct s_PXENV_TFTP_READ *tftp_read );
-
 /** @} */ /* pxenv_tftp_read */
 
 /** @defgroup pxenv_tftp_read_file PXENV_TFTP_READ_FILE
@@ -690,9 +668,6 @@ struct s_PXENV_TFTP_READ_FILE {
 
 typedef struct s_PXENV_TFTP_READ_FILE PXENV_TFTP_READ_FILE_t;
 
-extern PXENV_EXIT_t pxenv_tftp_read_file ( struct s_PXENV_TFTP_READ_FILE
-					   *tftp_read_file );
-
 /** @} */ /* pxenv_tftp_read_file */
 
 /** @defgroup pxenv_tftp_get_fsize PXENV_TFTP_GET_FSIZE
@@ -716,9 +691,6 @@ struct s_PXENV_TFTP_GET_FSIZE {
 
 typedef struct s_PXENV_TFTP_GET_FSIZE PXENV_TFTP_GET_FSIZE_t;
 
-extern PXENV_EXIT_t pxenv_tftp_get_fsize ( struct s_PXENV_TFTP_GET_FSIZE
-					   *get_fsize );
-
 /** @} */ /* pxenv_tftp_get_fsize */
 
 /** @} */ /* pxe_tftp_api */
@@ -748,8 +720,6 @@ struct s_PXENV_UDP_OPEN {
 
 typedef struct s_PXENV_UDP_OPEN PXENV_UDP_OPEN_t;
 
-extern PXENV_EXIT_t pxenv_udp_open ( struct s_PXENV_UDP_OPEN *udp_open );
-
 /** @} */ /* pxenv_udp_open */
 
 /** @defgroup pxenv_udp_close PXENV_UDP_CLOSE
@@ -769,8 +739,6 @@ struct s_PXENV_UDP_CLOSE {
 
 typedef struct s_PXENV_UDP_CLOSE PXENV_UDP_CLOSE_t;
 
-extern PXENV_EXIT_t pxenv_udp_close ( struct s_PXENV_UDP_CLOSE *udp_close );
-
 /** @} */ /* pxenv_udp_close */
 
 /** @defgroup pxenv_udp_write PXENV_UDP_WRITE
@@ -796,8 +764,6 @@ struct s_PXENV_UDP_WRITE {
 
 typedef struct s_PXENV_UDP_WRITE PXENV_UDP_WRITE_t;
 
-extern PXENV_EXIT_t pxenv_udp_write ( struct s_PXENV_UDP_WRITE *udp_write );
-
 /** @} */ /* pxenv_udp_write */
 
 /** @defgroup pxenv_udp_read PXENV_UDP_READ
@@ -823,8 +789,6 @@ struct s_PXENV_UDP_READ {
 
 typedef struct s_PXENV_UDP_READ PXENV_UDP_READ_t;
 
-extern PXENV_EXIT_t pxenv_udp_read ( struct s_PXENV_UDP_READ *udp_read );
-
 /** @} */ /* pxenv_udp_read */
 
 /** @} */ /* pxe_udp_api */
@@ -860,9 +824,6 @@ struct s_PXENV_UNDI_STARTUP {
 
 typedef struct s_PXENV_UNDI_STARTUP PXENV_UNDI_STARTUP_t;
 
-extern PXENV_EXIT_t pxenv_undi_startup ( struct s_PXENV_UNDI_STARTUP
-					 *undi_startup );
-
 /** @} */ /* pxenv_undi_startup */
 
 /** @defgroup pxenv_undi_cleanup PXENV_UNDI_CLEANUP
@@ -882,9 +843,6 @@ struct s_PXENV_UNDI_CLEANUP {
 
 typedef struct s_PXENV_UNDI_CLEANUP PXENV_UNDI_CLEANUP_t;
 
-extern PXENV_EXIT_t pxenv_undi_cleanup ( struct s_PXENV_UNDI_CLEANUP
-					 *undi_cleanup );
-
 /** @} */ /* pxenv_undi_cleanup */
 
 /** @defgroup pxenv_undi_initialize PXENV_UNDI_INITIALIZE
@@ -913,9 +871,6 @@ struct s_PXENV_UNDI_INITIALIZE {
 
 typedef struct s_PXENV_UNDI_INITIALIZE PXENV_UNDI_INITIALIZE_t;
 
-extern PXENV_EXIT_t pxenv_undi_initialize ( struct s_PXENV_UNDI_INITIALIZE
-					    *undi_initialize );
-
 /** @} */ /* pxenv_undi_initialize */
 
 /** @defgroup pxenv_undi_reset_adapter PXENV_UNDI_RESET_ADAPTER
@@ -950,9 +905,6 @@ struct s_PXENV_UNDI_RESET {
 
 typedef struct s_PXENV_UNDI_RESET PXENV_UNDI_RESET_t;
 
-extern PXENV_EXIT_t pxenv_undi_reset_adapter ( struct s_PXENV_UNDI_RESET
-					       *undi_reset_adapter );
-
 /** @} */ /* pxenv_undi_reset_adapter */
 
 /** @defgroup pxenv_undi_shutdown PXENV_UNDI_SHUTDOWN
@@ -972,9 +924,6 @@ struct s_PXENV_UNDI_SHUTDOWN {
 
 typedef struct s_PXENV_UNDI_SHUTDOWN PXENV_UNDI_SHUTDOWN_t;
 
-extern PXENV_EXIT_t pxenv_undi_shutdown ( struct s_PXENV_UNDI_SHUTDOWN
-					  *undi_shutdown );
-
 /** @} */ /* pxenv_undi_shutdown */
 
 /** @defgroup pxenv_undi_open PXENV_UNDI_OPEN
@@ -1024,8 +973,6 @@ struct s_PXENV_UNDI_OPEN {
 
 typedef struct s_PXENV_UNDI_OPEN PXENV_UNDI_OPEN_t;
 
-extern PXENV_EXIT_t pxenv_undi_open ( struct s_PXENV_UNDI_OPEN *undi_open );
-
 /** @} */ /* pxenv_undi_open */
 
 /** @defgroup pxenv_undi_close PXENV_UNDI_CLOSE
@@ -1045,8 +992,6 @@ struct s_PXENV_UNDI_CLOSE {
 
 typedef struct s_PXENV_UNDI_CLOSE PXENV_UNDI_CLOSE_t;
 
-extern PXENV_EXIT_t pxenv_undi_close ( struct s_PXENV_UNDI_CLOSE *undi_close );
-
 /** @} */ /* pxenv_undi_close */
 
 /** @defgroup pxenv_undi_transmit PXENV_UNDI_TRANSMIT
@@ -1122,9 +1067,6 @@ struct s_PXENV_UNDI_TRANSMIT {
 
 typedef struct s_PXENV_UNDI_TRANSMIT PXENV_UNDI_TRANSMIT_t;
 
-extern PXENV_EXIT_t pxenv_undi_transmit ( struct s_PXENV_UNDI_TRANSMIT
-					  *undi_transmit );
-
 /** @} */ /* pxenv_undi_transmit */
 
 /** @defgroup pxenv_undi_set_mcast_address PXENV_UNDI_SET_MCAST_ADDRESS
@@ -1146,9 +1088,6 @@ struct s_PXENV_UNDI_SET_MCAST_ADDRESS {
 
 typedef struct s_PXENV_UNDI_SET_MCAST_ADDRESS PXENV_UNDI_SET_MCAST_ADDRESS_t;
 
-extern PXENV_EXIT_t pxenv_undi_set_mcast_address (
-	       struct s_PXENV_UNDI_SET_MCAST_ADDRESS *undi_set_mcast_address );
-
 /** @} */ /* pxenv_undi_set_mcast_address */
 
 /** @defgroup pxenv_undi_set_station_address PXENV_UNDI_SET_STATION_ADDRESS
@@ -1169,9 +1108,6 @@ struct s_PXENV_UNDI_SET_STATION_ADDRESS {
 
 typedef struct s_PXENV_UNDI_SET_STATION_ADDRESS PXENV_UNDI_SET_STATION_ADDRESS_t;
 
-extern PXENV_EXIT_t pxenv_undi_set_station_address (
-	   struct s_PXENV_UNDI_SET_STATION_ADDRESS *undi_set_station_address );
-
 /** @} */ /* pxenv_undi_set_station_address */
 
 /** @defgroup pxenv_undi_set_packet_filter PXENV_UNDI_SET_PACKET_FILTER
@@ -1202,9 +1138,6 @@ struct s_PXENV_UNDI_SET_PACKET_FILTER {
 
 typedef struct s_PXENV_UNDI_SET_PACKET_FILTER PXENV_UNDI_SET_PACKET_FILTER_t;
 
-extern PXENV_EXIT_t pxenv_undi_set_packet_filter (
-	       struct s_PXENV_UNDI_SET_PACKET_FILTER *undi_set_packet_filter );
-
 /** @} */ /* pxenv_undi_set_packet_filter */
 
 /** @defgroup pxenv_undi_get_information PXENV_UNDI_GET_INFORMATION
@@ -1248,9 +1181,6 @@ struct s_PXENV_UNDI_GET_INFORMATION {
 
 typedef struct s_PXENV_UNDI_GET_INFORMATION PXENV_UNDI_GET_INFORMATION_t;
 
-extern PXENV_EXIT_t pxenv_undi_get_information (
-		   struct s_PXENV_UNDI_GET_INFORMATION *undi_get_information );
-
 /** @} */ /* pxenv_undi_get_information */
 
 /** @defgroup pxenv_undi_get_statistics PXENV_UNDI_GET_STATISTICS
@@ -1274,9 +1204,6 @@ struct s_PXENV_UNDI_GET_STATISTICS {
 
 typedef struct s_PXENV_UNDI_GET_STATISTICS PXENV_UNDI_GET_STATISTICS_t;
 
-extern PXENV_EXIT_t pxenv_undi_get_statistics (
-		     struct s_PXENV_UNDI_GET_STATISTICS *undi_get_statistics );
-
 /** @} */ /* pxenv_undi_get_statistics */
 
 /** @defgroup pxenv_undi_clear_statistics PXENV_UNDI_CLEAR_STATISTICS
@@ -1296,9 +1223,6 @@ struct s_PXENV_UNDI_CLEAR_STATISTICS {
 
 typedef struct s_PXENV_UNDI_CLEAR_STATISTICS PXENV_UNDI_CLEAR_STATISTICS_t;
 
-extern PXENV_EXIT_t pxenv_undi_clear_statistics (
-		 struct s_PXENV_UNDI_CLEAR_STATISTICS *undi_clear_statistics );
-
 /** @} */ /* pxenv_undi_clear_statistics */
 
 /** @defgroup pxenv_undi_initiate_diags PXENV_UNDI_INITIATE_DIAGS
@@ -1318,9 +1242,6 @@ struct s_PXENV_UNDI_INITIATE_DIAGS {
 
 typedef struct s_PXENV_UNDI_INITIATE_DIAGS PXENV_UNDI_INITIATE_DIAGS_t;
 
-extern PXENV_EXIT_t pxenv_undi_initiate_diags (
-		     struct s_PXENV_UNDI_INITIATE_DIAGS *undi_initiate_diags );
-
 /** @} */ /* pxenv_undi_initiate_diags */
 
 /** @defgroup pxenv_undi_force_interrupt PXENV_UNDI_FORCE_INTERRUPT
@@ -1340,9 +1261,6 @@ struct s_PXENV_UNDI_FORCE_INTERRUPT {
 
 typedef struct s_PXENV_UNDI_FORCE_INTERRUPT PXENV_UNDI_FORCE_INTERRUPT_t;
 
-extern PXENV_EXIT_t pxenv_undi_force_interrupt (
-		   struct s_PXENV_UNDI_FORCE_INTERRUPT *undi_force_interrupt );
-
 /** @} */ /* pxenv_undi_force_interrupt */
 
 /** @defgroup pxenv_undi_get_mcast_address PXENV_UNDI_GET_MCAST_ADDRESS
@@ -1364,9 +1282,6 @@ struct s_PXENV_UNDI_GET_MCAST_ADDRESS {
 
 typedef struct s_PXENV_UNDI_GET_MCAST_ADDRESS PXENV_UNDI_GET_MCAST_ADDRESS_t;
 
-extern PXENV_EXIT_t pxenv_undi_get_mcast_address (
-	       struct s_PXENV_UNDI_GET_MCAST_ADDRESS *undi_get_mcast_address );
-
 /** @} */ /* pxenv_undi_get_mcast_address */
 
 /** @defgroup pxenv_undi_get_nic_type PXENV_UNDI_GET_NIC_TYPE
@@ -1427,9 +1342,6 @@ struct s_PXENV_UNDI_GET_NIC_TYPE {
 
 typedef struct s_PXENV_UNDI_GET_NIC_TYPE PXENV_UNDI_GET_NIC_TYPE_t;
 
-extern PXENV_EXIT_t pxenv_undi_get_nic_type ( 
-			 struct s_PXENV_UNDI_GET_NIC_TYPE *undi_get_nic_type );
-
 /** @} */ /* pxenv_undi_get_nic_type */
 
 /** @defgroup pxenv_undi_get_iface_info PXENV_UNDI_GET_IFACE_INFO
@@ -1488,9 +1400,6 @@ struct s_PXENV_UNDI_GET_IFACE_INFO {
 
 typedef struct s_PXENV_UNDI_GET_IFACE_INFO PXENV_UNDI_GET_IFACE_INFO_t;
 
-extern PXENV_EXIT_t pxenv_undi_get_iface_info (
-		     struct s_PXENV_UNDI_GET_IFACE_INFO *undi_get_iface_info );
-
 /** @} */ /* pxenv_undi_get_iface_info */
 
 /** @defgroup pxenv_undi_get_state PXENV_UNDI_GET_STATE
@@ -1524,9 +1433,6 @@ struct s_PXENV_UNDI_GET_STATE {
 
 typedef struct s_PXENV_UNDI_GET_STATE PXENV_UNDI_GET_STATE_t;
 
-extern PXENV_EXIT_t pxenv_undi_get_state ( struct s_PXENV_UNDI_GET_STATE
-					   *undi_get_state );
-
 /** @} */ /* pxenv_undi_get_state */
 
 /** @defgroup pxenv_undi_isr PXENV_UNDI_ISR
@@ -1595,8 +1501,6 @@ struct s_PXENV_UNDI_ISR {
 
 typedef struct s_PXENV_UNDI_ISR PXENV_UNDI_ISR_t;
 
-extern PXENV_EXIT_t pxenv_undi_isr ( struct s_PXENV_UNDI_ISR *undi_isr );
-
 /** @} */ /* pxenv_undi_isr */
 
 /** @} */ /* pxe_undi_api */
@@ -1608,6 +1512,12 @@ extern PXENV_EXIT_t pxenv_undi_isr ( struct s_PXENV_UNDI_ISR *undi_isr );
  * @{
  */
 
+/** Minimum possible opcode used within PXE FILE API */
+#define PXENV_FILE_MIN 0x00e0
+
+/** Minimum possible opcode used within PXE FILE API */
+#define PXENV_FILE_MAX 0x00ef
+
 /** @defgroup pxenv_file_open PXENV_FILE_OPEN
  *
  * FILE OPEN
@@ -1628,8 +1538,6 @@ struct s_PXENV_FILE_OPEN {
 
 typedef struct s_PXENV_FILE_OPEN PXENV_FILE_OPEN_t;
 
-extern PXENV_EXIT_t pxenv_file_open ( struct s_PXENV_FILE_OPEN *file_open );
-
 /** @} */ /* pxenv_file_open */
 
 /** @defgroup pxenv_file_close PXENV_FILE_CLOSE
@@ -1650,9 +1558,6 @@ struct s_PXENV_FILE_CLOSE {
 
 typedef struct s_PXENV_FILE_CLOSE PXENV_FILE_CLOSE_t;
 
-extern PXENV_EXIT_t pxenv_file_close ( struct s_PXENV_FILE_CLOSE
-				       *file_close );
-
 /** @} */ /* pxenv_file_close */
 
 /** @defgroup pxenv_file_select PXENV_FILE_SELECT
@@ -1677,9 +1582,6 @@ struct s_PXENV_FILE_SELECT {
 
 typedef struct s_PXENV_FILE_SELECT PXENV_FILE_SELECT_t;
 
-extern PXENV_EXIT_t pxenv_file_select ( struct s_PXENV_FILE_SELECT
-					*file_select );
-
 /** @} */ /* pxenv_file_select */
 
 /** @defgroup pxenv_file_read PXENV_FILE_READ
@@ -1702,8 +1604,6 @@ struct s_PXENV_FILE_READ {
 
 typedef struct s_PXENV_FILE_READ PXENV_FILE_READ_t;
 
-extern PXENV_EXIT_t pxenv_file_read ( struct s_PXENV_FILE_READ *file_read );
-
 /** @} */ /* pxenv_file_read */
 
 /** @defgroup pxenv_get_file_size PXENV_GET_FILE_SIZE
@@ -1725,9 +1625,6 @@ struct s_PXENV_GET_FILE_SIZE {
 
 typedef struct s_PXENV_GET_FILE_SIZE PXENV_GET_FILE_SIZE_t;
 
-extern PXENV_EXIT_t pxenv_get_file_size ( struct s_PXENV_GET_FILE_SIZE
-					  *get_file_size );
-
 /** @} */ /* pxenv_get_file_size */
 
 /** @defgroup pxenv_file_exec PXENV_FILE_EXEC
@@ -1748,8 +1645,6 @@ struct s_PXENV_FILE_EXEC {
 
 typedef struct s_PXENV_FILE_EXEC PXENV_FILE_EXEC_t;
 
-extern PXENV_EXIT_t pxenv_file_exec ( struct s_PXENV_FILE_EXEC *file_exec );
-
 /** @} */ /* pxenv_file_exec */
 
 /** @defgroup pxenv_file_api_check PXENV_FILE_API_CHECK
@@ -1774,8 +1669,6 @@ struct s_PXENV_FILE_API_CHECK {
 
 typedef struct s_PXENV_FILE_API_CHECK PXENV_FILE_API_CHECK_t;
 
-extern PXENV_EXIT_t pxenv_file_api_check ( struct s_PXENV_FILE_API_CHECK *file_api_check );
-
 /** @} */ /* pxenv_file_api_check */
 
 /** @defgroup pxenv_file_exit_hook PXENV_FILE_EXIT_HOOK
@@ -1796,10 +1689,29 @@ struct s_PXENV_FILE_EXIT_HOOK {
 
 typedef struct s_PXENV_FILE_EXIT_HOOK PXENV_FILE_EXIT_HOOK_t;
 
-extern PXENV_EXIT_t pxenv_file_exit_hook ( struct s_PXENV_FILE_EXIT_HOOK *file_exit_hook );
-
 /** @} */ /* pxenv_file_exit_hook */
 
+/** @defgroup pxenv_file_cmdline PXENV_FILE_CMDLINE
+ *
+ * FILE CMDLINE
+ *
+ * @{
+ */
+
+/** PXE API function code for pxenv_file_cmdline() */
+#define PXENV_FILE_CMDLINE			0x00e8
+
+/** Parameter block for pxenv_file_cmdline() */
+struct s_PXENV_FILE_CMDLINE {
+	PXENV_STATUS_t Status;		/**< PXE status code */
+	UINT16_t BufferSize;		/**< Data buffer size */
+	SEGOFF16_t Buffer;		/**< Data buffer */
+} __attribute__ (( packed ));
+
+typedef struct s_PXENV_FILE_CMDLINE PXENV_FILE_CMDLINE_t;
+
+/** @} */ /* pxe_file_cmdline */
+
 /** @} */ /* pxe_file_api */
 
 /** @defgroup pxe_loader_api PXE Loader API
@@ -1847,8 +1759,6 @@ struct s_UNDI_LOADER {
 
 typedef struct s_UNDI_LOADER UNDI_LOADER_t;
 
-extern PXENV_EXIT_t undi_loader ( struct s_UNDI_LOADER *undi_loader );
-
 /** @} */ /* pxe_loader_api */
 
 /** @} */ /* pxe */
diff --git a/roms/ipxe/src/arch/i386/include/rtc.h b/roms/ipxe/src/arch/i386/include/rtc.h
new file mode 100644
index 0000000000000000000000000000000000000000..2a6abbae57295430932424680c2dbd349471e0eb
--- /dev/null
+++ b/roms/ipxe/src/arch/i386/include/rtc.h
@@ -0,0 +1,83 @@
+#ifndef _RTC_H
+#define _RTC_H
+
+/** @file
+ *
+ * CMOS Real-Time Clock (RTC)
+ *
+ * The CMOS/RTC registers are documented (with varying degrees of
+ * accuracy and consistency) at
+ *
+ *    http://www.nondot.org/sabre/os/files/MiscHW/RealtimeClockFAQ.txt
+ *    http://wiki.osdev.org/RTC
+ *    http://wiki.osdev.org/CMOS
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <pic8259.h>
+
+/** RTC IRQ */
+#define RTC_IRQ 8
+
+/** RTC interrupt vector */
+#define RTC_INT IRQ_INT ( RTC_IRQ )
+
+/** CMOS/RTC address (and NMI) register */
+#define CMOS_ADDRESS 0x70
+
+/** NMI disable bit */
+#define CMOS_DISABLE_NMI 0x80
+
+/** CMOS/RTC data register */
+#define CMOS_DATA 0x71
+
+/** RTC seconds */
+#define RTC_SEC 0x00
+
+/** RTC minutes */
+#define RTC_MIN 0x02
+
+/** RTC hours */
+#define RTC_HOUR 0x04
+
+/** RTC weekday */
+#define RTC_WDAY 0x06
+
+/** RTC day of month */
+#define RTC_MDAY 0x07
+
+/** RTC month */
+#define RTC_MON 0x08
+
+/** RTC year */
+#define RTC_YEAR 0x09
+
+/** RTC status register A */
+#define RTC_STATUS_A 0x0a
+
+/** RTC update in progress bit */
+#define RTC_STATUS_A_UPDATE_IN_PROGRESS 0x80
+
+/** RTC status register B */
+#define RTC_STATUS_B 0x0b
+
+/** RTC 24 hour format bit */
+#define RTC_STATUS_B_24_HOUR 0x02
+
+/** RTC binary mode bit */
+#define RTC_STATUS_B_BINARY 0x04
+
+/** RTC Periodic Interrupt Enabled bit */
+#define RTC_STATUS_B_PIE 0x40
+
+/** RTC status register C */
+#define RTC_STATUS_C 0x0c
+
+/** RTC status register D */
+#define RTC_STATUS_D 0x0d
+
+/** CMOS default address */
+#define CMOS_DEFAULT_ADDRESS RTC_STATUS_D
+
+#endif /* _RTC_H */
diff --git a/roms/ipxe/src/arch/i386/include/sdi.h b/roms/ipxe/src/arch/i386/include/sdi.h
new file mode 100644
index 0000000000000000000000000000000000000000..fc486402d1894adf52f5fedf74444719a14c3d9a
--- /dev/null
+++ b/roms/ipxe/src/arch/i386/include/sdi.h
@@ -0,0 +1,39 @@
+#ifndef _SDI_H
+#define _SDI_H
+
+/** @file
+ *
+ * System Deployment Image (SDI)
+ *
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** SDI image header */
+struct sdi_header {
+	/** Signature */
+	uint32_t magic;
+	/** Version (as an ASCII string) */
+	uint32_t version;
+	/** Reserved */
+	uint8_t reserved[8];
+	/** Boot code offset */
+	uint64_t boot_offset;
+	/** Boot code size */
+	uint64_t boot_size;
+} __attribute__ (( packed ));
+
+/** SDI image signature */
+#define SDI_MAGIC \
+	( ( '$' << 0 ) | ( 'S' << 8 ) | ( 'D' << 16 ) | ( 'I' << 24 ) )
+
+/** SDI boot segment */
+#define SDI_BOOT_SEG 0x0000
+
+/** SDI boot offset */
+#define SDI_BOOT_OFF 0x7c00
+
+/** Constant to binary-OR with physical address of SDI image */
+#define SDI_WTF 0x41
+
+#endif /* _SDI_H */
diff --git a/roms/ipxe/src/arch/i386/interface/pcbios/bios_smbios.c b/roms/ipxe/src/arch/i386/interface/pcbios/bios_smbios.c
index cde3d0603f9454d5dd24d6203ade..76a32e93db69081b8962d3068e4f 100644
--- a/roms/ipxe/src/arch/i386/interface/pcbios/bios_smbios.c
+++ b/roms/ipxe/src/arch/i386/interface/pcbios/bios_smbios.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -76,6 +77,8 @@ static int bios_find_smbios ( struct smbios *smbios ) {
 		smbios->address = phys_to_user ( u.entry.smbios_address );
 		smbios->len = u.entry.smbios_len;
 		smbios->count = u.entry.smbios_count;
+		smbios->version =
+			SMBIOS_VERSION ( u.entry.major, u.entry.minor );
 		return 0;
 	}
 
diff --git a/roms/ipxe/src/arch/i386/interface/pcbios/bios_timer.c b/roms/ipxe/src/arch/i386/interface/pcbios/bios_timer.c
index 70c3986b1252626c7a4c8e44479d..3cb8756f74841662f2874f3c4cdd 100644
--- a/roms/ipxe/src/arch/i386/interface/pcbios/bios_timer.c
+++ b/roms/ipxe/src/arch/i386/interface/pcbios/bios_timer.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
